#include "game.h"
#include "archi.h"
#include "palette.h"
#include "menu.h"
#include "points.h"

#include <stdlib.h>
#include <time.h>

/* the different colors for the eight towers */
static struct {
  unsigned char r, g, b;
} tcolors[8] = {
  { 255, 0, 0 },
  { 150, 150, 255 },
  { 170, 170, 170 },
  { 163, 120, 88 },
  { 0, 155, 155 },
  { 255, 100, 100 },
  { 150, 255, 150 },
  { 255, 155, 0 }
};

static void startgame() {

  unsigned char stat, tower;
  int anglepos;
  int gameresult;
  int resttime;

  arc_init("nebulous.dat");
  gam_init();
  men_init();
  gam_intro();
  stat = men_main(true);
  while (stat > 0) {
    pts_reset();
    gam_newgame();
    tower = 0;
    do {
      pal_settowercolor(tcolors[tower].r, tcolors[tower].g, tcolors[tower].b);
      pal_calcdark();
      do {
        gam_loadtower(tower);
        gam_arrival();
        gameresult = gam_towergame(anglepos, resttime);
      } while ((gameresult == GAME_DIED) && pts_lifesleft());
      if (gameresult == GAME_FINISHED) {
        gam_pick_up(anglepos, resttime);
        /*
        if (tower < 7)
          gam_submarinegame();
        */
        tower++;
      }
    } while (pts_lifesleft() && (tower != 8) && (gameresult != GAME_ABBORTED));
    /*
    if (tower == 8)
      game.masterpic;
    */
    men_highscore(pts_points(), true);
    stat = men_main(false);
  }
  gam_done();
  arc_done();
}


main(int argc, char *argv[]) {
  SDL_Init(SDL_INIT_VIDEO);
  SDL_WM_SetCaption("Nebulous", NULL); 
  atexit(SDL_Quit);
  printf("\nNebulous\n");
  srand(time(0));
  startgame();
  SDL_Quit();
  return 0;
}

